unit MathicMath;
interface
uses
  Messages, Graphics, Controls, Forms, classes, ExtCtrls,SysUtils;
type
  TMathicMath = class(TPaintBox)
  private
    text:string;
    cadr:TColor;
    epaiss:integer;
    cadrvisi:boolean;
    charbarr:char;
    pas_fraction:TNotifyEvent;
    fraction:TNotifyEvent;
    chang:TNotifyEvent;
    errapproxi:TNotifyEvent;
    approxi:boolean;
   procedure Set_Cadrvisi(value:boolean);
   procedure Set_Epaiss(value:Integer);
   procedure Set_Cadr(value:TColor);
   procedure Set_text(value:string);
   procedure Set_Charbarr(value:char);
   procedure Set_Approxi(value:Boolean);
  protected
   procedure paint; override;
  public
   constructor Create(AOwner:TComponent);override;
  published
   property Texte:String read text write Set_text;
   property Cadre:TColor read cadr write Set_Cadr;
   property Epaisseur:Integer read epaiss write Set_Epaiss;
   property CadreVisible:Boolean read cadrvisi write Set_Cadrvisi;
   property CharBarre:Char read charbarr write Set_Charbarr;
   property OnPasFraction:TNotifyEvent read pas_fraction write pas_fraction;
   property OnFraction:TNotifyEvent read fraction write fraction;
   property OnChange:TNotifyEvent read chang write chang;
   property Approximation:Boolean read approxi write Set_Approxi;
   property OnErreurApproximation:TNotifyEvent read errapproxi write errapproxi;
  end;
procedure Register;
implementation
procedure TMathicMath.Set_Approxi(value:Boolean);
begin
approxi:=value;
paint;
end;
procedure TMathicMath.Set_Charbarr(value:char);
begin
charbarr:=value;
paint;
end;
constructor TMathicMath.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
  text:='Dividende|Diviseur';
  charbarr:='|';
  cadr:=clblack;
  color:=clwhite;
  epaiss:=2;
  cadrvisi:=True;
end;
procedure TMathicMath.Set_Cadrvisi(value:boolean);
begin
cadrvisi:=value;
paint;
end;
procedure TMathicMath.Set_Epaiss(value:Integer);
begin
epaiss:=value;
paint;
end;
procedure TMathicMath.Set_Cadr(value:TColor);
begin
cadr:=value;
paint;
end;

procedure TMathicMath.Set_text(value:string);
begin
text:=value;
if assigned(chang) then chang(self);
paint;
end;
procedure TMathicMath.paint;
var
   diviseur :string;diviseur_val:real;
   dividende:string;dividende_val:real;
   fraction_val:String;
   position_barre:integer;
   longueur_fraction:integer;
///
   texte_fraction:string;
begin
canvas.brush.Color:=color;
canvas.Pen.Width:=epaiss;
//   Rglage des paramtres :
canvas.Font.Size := font.Size;
//   Cadre :
if cadrvisi then begin
   canvas.pen.Color := cadr;
   canvas.Rectangle(1,1,width-1,height-1);
end else begin
   canvas.pen.Color := color;
   canvas.Rectangle(1,1,width-1,height-1);
end;
// Affichage de fraction :
   texte_fraction:=text;
   position_barre:=1;
   canvas.font.color:=font.color;
   canvas.pen.Color := font.color;
   repeat
         inc(position_barre);
   until (copy(texte_fraction,position_barre,1) = charbarr)
      or(position_barre>length(texte_fraction));
if (copy(texte_fraction,position_barre,1) = charbarr) then begin
   dividende := copy(texte_fraction,0,position_barre-1);
   diviseur  := copy(texte_fraction,position_barre+1,999);
   if canvas.TextWidth(dividende) > canvas.TextWidth(diviseur) then
      longueur_fraction:= canvas.TextWidth(dividende)
   else
      longueur_fraction:= canvas.TextWidth(diviseur);
   canvas.MoveTo(width div 2 - longueur_fraction div 2,height div 2);
   canvas.LineTo(width div 2 + longueur_fraction div 2,height div 2);

   canvas.textout(width div 2 - canvas.TextWidth(dividende)div 2 ,
      (height div 2)+canvas.Font.Height-6 , dividende);
   canvas.textout(width div 2 - canvas.TextWidth(diviseur)div 2 ,
      height div 2 + 2, diviseur);
   if assigned(OnFraction) then OnFraction(Self);
// Centre en hauteur du texte:
end else begin
      canvas.textout(width div 2 - canvas.TextWidth(text) div 2,
         height div 2 + canvas.Font.Height div 2, text);
      if assigned(pas_fraction) then pas_fraction(Self);
end;
if approxi then begin
   try
      dividende_val := strtoFloat(dividende);
      diviseur_val := strtoFloat(diviseur);
      fraction_val := FloatToStr(dividende_val / diviseur_val);
      canvas.Font.size:=5;
      canvas.textout(width-canvas.TextWidth(fraction_val)-4,
         height-canvas.TextHeight(fraction_val)-4, fraction_val);
      canvas.font.size:=font.size;

   except
      canvas.Font.size:=5;
      canvas.font.color:=clmaroon;
      canvas.textout(width-canvas.TextWidth('erreur')-4,
         height-canvas.TextHeight('erreur')-4, 'erreur');
      canvas.font.color:=font.color;
      canvas.font.size:=font.size;
      if assigned(errapproxi) then errapproxi(Self);
   end;
end;
if csdesigning in componentState then begin
   canvas.Font.size:=5;
   canvas.font.color:=clred;
   canvas.textout(4,4, 'netProblMATHique - Mode dition');
   canvas.textout(4,height-canvas.TextHeight('http://www.mathic.ovh.org')-4,
       'http://www.mathic.ovh.org');
   canvas.font.size:=font.size;
   canvas.font.color:=font.color;
end;
if cadrvisi then begin
   canvas.brush.style:=bsCLear;
   canvas.pen.Color := cadr;
   canvas.Rectangle(1,1,width-1,height-1);
   canvas.brush.style:=bsSolid;

end;
end;
procedure Register;
begin
  RegisterComponents('Exemples', [TMathicMath]);
end;
end.
